#if UNITY_EDITOR || UNITY_STANDALONE
using System;
using System.Runtime.InteropServices;

namespace FFmpeg.AutoGen
{
    public unsafe partial struct AVDictionary
    {
    }
    
    public unsafe partial struct AVBuffer
    {
    }
    
    public unsafe partial struct AVBufferPool
    {
    }
    
    public unsafe partial struct AVFilterContext
    {
    }
    
    public unsafe partial struct AVFilterLink
    {
    }
    
    public unsafe partial struct AVFilterPad
    {
    }
    
    public unsafe partial struct AVFilterFormats
    {
    }
    
    public unsafe partial struct AVFilter
    {
        public sbyte* @name;
        public sbyte* @description;
        public AVFilterPad* @inputs;
        public AVFilterPad* @outputs;
        public AVClass* @priv_class;
        public int @flags;
        public IntPtr @init;
        public IntPtr @init_dict;
        public IntPtr @uninit;
        public IntPtr @query_formats;
        public int @priv_size;
        public AVFilter* @next;
        public IntPtr @process_command;
        public IntPtr @init_opaque;
    }
    
    public unsafe partial struct AVFilterInternal
    {
    }
    
    public unsafe partial struct AVFilterContext
    {
        public AVClass* @av_class;
        public AVFilter* @filter;
        public sbyte* @name;
        public AVFilterPad* @input_pads;
        public AVFilterLink** @inputs;
        public uint @nb_inputs;
        public AVFilterPad* @output_pads;
        public AVFilterLink** @outputs;
        public uint @nb_outputs;
        public void* @priv;
        public AVFilterGraph* @graph;
        public int @thread_type;
        public AVFilterInternal* @internal;
        public AVFilterCommand* @command_queue;
        public sbyte* @enable_str;
        public void* @enable;
        public double* @var_values;
        public int @is_disabled;
    }
    
    public unsafe partial struct AVFilterCommand
    {
    }
    
    public unsafe partial struct AVFilterGraph
    {
    }
    
    public unsafe partial struct AVFilterLink
    {
        public AVFilterContext* @src;
        public AVFilterPad* @srcpad;
        public AVFilterContext* @dst;
        public AVFilterPad* @dstpad;
        public AVMediaType @type;
        public int @w;
        public int @h;
        public AVRational @sample_aspect_ratio;
        public ulong @channel_layout;
        public int @sample_rate;
        public int @format;
        public AVRational @time_base;
        public AVFilterFormats* @in_formats;
        public AVFilterFormats* @out_formats;
        public AVFilterFormats* @in_samplerates;
        public AVFilterFormats* @out_samplerates;
        public AVFilterChannelLayouts* @in_channel_layouts;
        public AVFilterChannelLayouts* @out_channel_layouts;
        public int @request_samples;
        public init_state @init_state;
        public AVFilterGraph* @graph;
        public long @current_pts;
        public long @current_pts_us;
        public int @age_index;
        public AVRational @frame_rate;
        public AVFrame* @partial_buf;
        public int @partial_buf_size;
        public int @min_samples;
        public int @max_samples;
        public int @status;
        public int @channels;
        public uint @flags;
        public long @frame_count;
        public void* @video_frame_pool;
        public int @frame_wanted_in;
        public int @frame_wanted_out;
    }
    
    public unsafe partial struct AVFilterChannelLayouts
    {
    }
    
    public unsafe partial struct AVFilterGraphInternal
    {
    }
    
    public unsafe partial struct AVFilterGraph
    {
        public AVClass* @av_class;
        public AVFilterContext** @filters;
        public uint @nb_filters;
        public sbyte* @scale_sws_opts;
        public sbyte* @resample_lavr_opts;
        public int @thread_type;
        public int @nb_threads;
        public AVFilterGraphInternal* @internal;
        public void* @opaque;
        public IntPtr @execute;
        public sbyte* @aresample_swr_opts;
        public AVFilterLink** @sink_links;
        public int @sink_links_count;
        public uint @disable_auto_convert;
    }
    
    public unsafe partial struct AVFilterInOut
    {
        public sbyte* @name;
        public AVFilterContext* @filter_ctx;
        public int @pad_idx;
        public AVFilterInOut* @next;
    }
    
    public unsafe partial struct AVBuffer
    {
    }
    
    public unsafe partial struct AVBufferPool
    {
    }
    
    public unsafe partial struct AVBPrint
    {
    }
    
    public unsafe partial struct AVDictionary
    {
    }
    
    public unsafe partial struct AVCodecInternal
    {
    }
    
    public unsafe partial struct AVCodecDefault
    {
    }
    
    public unsafe partial struct MpegEncContext
    {
    }
    
    public unsafe partial struct ReSampleContext
    {
    }
    
    public unsafe partial struct AVResampleContext
    {
    }
    
    public unsafe partial struct AVFilterPad
    {
    }
    
    public unsafe partial struct AVFilterFormats
    {
    }
    
    public unsafe partial struct AVFilterInternal
    {
    }
    
    public unsafe partial struct AVFilterGraphInternal
    {
    }
    
    public unsafe partial struct AVDictionary
    {
    }
    
    public unsafe partial struct AVBuffer
    {
    }
    
    public unsafe partial struct AVBufferPool
    {
    }
    
    public unsafe partial struct AVFilterPad
    {
    }
    
    public unsafe partial struct AVFilterFormats
    {
    }
    
    public unsafe partial struct AVFilterInternal
    {
    }
    
    public unsafe partial struct AVFilterGraphInternal
    {
    }
    
    public unsafe partial struct AVBufferSinkParams
    {
        public AVPixelFormat* @pixel_fmts;
    }
    
    public unsafe partial struct AVABufferSinkParams
    {
        public AVSampleFormat* @sample_fmts;
        public long* @channel_layouts;
        public int* @channel_counts;
        public int @all_channel_counts;
        public int* @sample_rates;
    }
    
    public enum init_state : int
    {
        @AVLINK_UNINIT = 0,
        @AVLINK_STARTINIT = 1,
        @AVLINK_INIT = 2,
    }
    
    public enum avfilter_graph_config : int
    {
        @AVFILTER_AUTO_CONVERT_ALL = 0,
        @AVFILTER_AUTO_CONVERT_NONE = -1,
    }
    
    public enum av_buffersrc_get_nb_failed_requests : int
    {
        @AV_BUFFERSRC_FLAG_NO_CHECK_FORMAT = 1,
        @AV_BUFFERSRC_FLAG_PUSH = 4,
        @AV_BUFFERSRC_FLAG_KEEP_REF = 8,
    }
    
    public unsafe static partial class ffmpeg
    {
        public const int LIBAVFILTER_VERSION_MAJOR = 6;
        public const int LIBAVFILTER_VERSION_MINOR = 31;
        public const int LIBAVFILTER_VERSION_MICRO = 100;
        public const bool FF_API_OLD_FILTER_OPTS = (LIBAVFILTER_VERSION_MAJOR<7);
        public const bool FF_API_OLD_FILTER_OPTS_ERROR = (LIBAVFILTER_VERSION_MAJOR<7);
        public const bool FF_API_AVFILTER_OPEN = (LIBAVFILTER_VERSION_MAJOR<7);
        public const bool FF_API_AVFILTER_INIT_FILTER = (LIBAVFILTER_VERSION_MAJOR<7);
        public const bool FF_API_OLD_FILTER_REGISTER = (LIBAVFILTER_VERSION_MAJOR<7);
        public const bool FF_API_NOCONST_GET_NAME = (LIBAVFILTER_VERSION_MAJOR<7);
        public const int AVFILTER_FLAG_DYNAMIC_INPUTS = (1<<0);
        public const int AVFILTER_FLAG_DYNAMIC_OUTPUTS = (1<<1);
        public const int AVFILTER_FLAG_SLICE_THREADS = (1<<2);
        public const int AVFILTER_FLAG_SUPPORT_TIMELINE_GENERIC = (1<<16);
        public const int AVFILTER_FLAG_SUPPORT_TIMELINE_INTERNAL = (1<<17);
        public const int AVFILTER_FLAG_SUPPORT_TIMELINE = (AVFILTER_FLAG_SUPPORT_TIMELINE_GENERIC|AVFILTER_FLAG_SUPPORT_TIMELINE_INTERNAL);
        public const int AVFILTER_THREAD_SLICE = (1<<0);
        public const int AVFILTER_CMD_FLAG_ONE = 1;
        public const int AVFILTER_CMD_FLAG_FAST = 2;
        public const int AV_BUFFERSINK_FLAG_PEEK = 1;
        public const int AV_BUFFERSINK_FLAG_NO_REQUEST = 2;
        private const string libavfilter = "avfilter-6";
        
        [DllImport(libavfilter, EntryPoint = "avfilter_version", CallingConvention = CallingConvention.Cdecl)]
        public static extern uint avfilter_version();
        
        [DllImport(libavfilter, EntryPoint = "avfilter_configuration", CallingConvention = CallingConvention.Cdecl)]
        public static extern string avfilter_configuration();
        
        [DllImport(libavfilter, EntryPoint = "avfilter_license", CallingConvention = CallingConvention.Cdecl)]
        public static extern string avfilter_license();
        
        [DllImport(libavfilter, EntryPoint = "avfilter_pad_count", CallingConvention = CallingConvention.Cdecl)]
        public static extern int avfilter_pad_count(AVFilterPad* @pads);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_pad_get_name", CallingConvention = CallingConvention.Cdecl)]
        public static extern string avfilter_pad_get_name(AVFilterPad* @pads, int @pad_idx);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_pad_get_type", CallingConvention = CallingConvention.Cdecl)]
        public static extern AVMediaType avfilter_pad_get_type(AVFilterPad* @pads, int @pad_idx);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_link", CallingConvention = CallingConvention.Cdecl)]
        public static extern int avfilter_link(AVFilterContext* @src, uint @srcpad, AVFilterContext* @dst, uint @dstpad);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_link_free", CallingConvention = CallingConvention.Cdecl)]
        public static extern void avfilter_link_free(AVFilterLink** @link);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_link_get_channels", CallingConvention = CallingConvention.Cdecl)]
        public static extern int avfilter_link_get_channels(AVFilterLink* @link);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_link_set_closed", CallingConvention = CallingConvention.Cdecl)]
        public static extern void avfilter_link_set_closed(AVFilterLink* @link, int @closed);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_config_links", CallingConvention = CallingConvention.Cdecl)]
        public static extern int avfilter_config_links(AVFilterContext* @filter);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_process_command", CallingConvention = CallingConvention.Cdecl)]
        public static extern int avfilter_process_command(AVFilterContext* @filter, [MarshalAs(UnmanagedType.LPStr)] string @cmd, [MarshalAs(UnmanagedType.LPStr)] string @arg, IntPtr @res, int @res_len, int @flags);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_register_all", CallingConvention = CallingConvention.Cdecl)]
        public static extern void avfilter_register_all();
        
        [DllImport(libavfilter, EntryPoint = "avfilter_uninit", CallingConvention = CallingConvention.Cdecl)]
        public static extern void avfilter_uninit();
        
        [DllImport(libavfilter, EntryPoint = "avfilter_register", CallingConvention = CallingConvention.Cdecl)]
        public static extern int avfilter_register(AVFilter* @filter);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_get_by_name", CallingConvention = CallingConvention.Cdecl)]
        public static extern AVFilter* avfilter_get_by_name([MarshalAs(UnmanagedType.LPStr)] string @name);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_next", CallingConvention = CallingConvention.Cdecl)]
        public static extern AVFilter* avfilter_next(AVFilter* @prev);
        
        [DllImport(libavfilter, EntryPoint = "av_filter_next", CallingConvention = CallingConvention.Cdecl)]
        public static extern AVFilter** av_filter_next(AVFilter** @filter);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_open", CallingConvention = CallingConvention.Cdecl)]
        public static extern int avfilter_open(AVFilterContext** @filter_ctx, AVFilter* @filter, [MarshalAs(UnmanagedType.LPStr)] string @inst_name);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_init_filter", CallingConvention = CallingConvention.Cdecl)]
        public static extern int avfilter_init_filter(AVFilterContext* @filter, [MarshalAs(UnmanagedType.LPStr)] string @args, void* @opaque);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_init_str", CallingConvention = CallingConvention.Cdecl)]
        public static extern int avfilter_init_str(AVFilterContext* @ctx, [MarshalAs(UnmanagedType.LPStr)] string @args);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_init_dict", CallingConvention = CallingConvention.Cdecl)]
        public static extern int avfilter_init_dict(AVFilterContext* @ctx, AVDictionary** @options);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_free", CallingConvention = CallingConvention.Cdecl)]
        public static extern void avfilter_free(AVFilterContext* @filter);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_insert_filter", CallingConvention = CallingConvention.Cdecl)]
        public static extern int avfilter_insert_filter(AVFilterLink* @link, AVFilterContext* @filt, uint @filt_srcpad_idx, uint @filt_dstpad_idx);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_get_class", CallingConvention = CallingConvention.Cdecl)]
        public static extern AVClass* avfilter_get_class();
        
        [DllImport(libavfilter, EntryPoint = "avfilter_graph_alloc", CallingConvention = CallingConvention.Cdecl)]
        public static extern AVFilterGraph* avfilter_graph_alloc();
        
        [DllImport(libavfilter, EntryPoint = "avfilter_graph_alloc_filter", CallingConvention = CallingConvention.Cdecl)]
        public static extern AVFilterContext* avfilter_graph_alloc_filter(AVFilterGraph* @graph, AVFilter* @filter, [MarshalAs(UnmanagedType.LPStr)] string @name);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_graph_get_filter", CallingConvention = CallingConvention.Cdecl)]
        public static extern AVFilterContext* avfilter_graph_get_filter(AVFilterGraph* @graph, [MarshalAs(UnmanagedType.LPStr)] string @name);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_graph_add_filter", CallingConvention = CallingConvention.Cdecl)]
        public static extern int avfilter_graph_add_filter(AVFilterGraph* @graphctx, AVFilterContext* @filter);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_graph_create_filter", CallingConvention = CallingConvention.Cdecl)]
        public static extern int avfilter_graph_create_filter(AVFilterContext** @filt_ctx, AVFilter* @filt, [MarshalAs(UnmanagedType.LPStr)] string @name, [MarshalAs(UnmanagedType.LPStr)] string @args, void* @opaque, AVFilterGraph* @graph_ctx);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_graph_set_auto_convert", CallingConvention = CallingConvention.Cdecl)]
        public static extern void avfilter_graph_set_auto_convert(AVFilterGraph* @graph, uint @flags);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_graph_config", CallingConvention = CallingConvention.Cdecl)]
        public static extern int avfilter_graph_config(AVFilterGraph* @graphctx, void* @log_ctx);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_graph_free", CallingConvention = CallingConvention.Cdecl)]
        public static extern void avfilter_graph_free(AVFilterGraph** @graph);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_inout_alloc", CallingConvention = CallingConvention.Cdecl)]
        public static extern AVFilterInOut* avfilter_inout_alloc();
        
        [DllImport(libavfilter, EntryPoint = "avfilter_inout_free", CallingConvention = CallingConvention.Cdecl)]
        public static extern void avfilter_inout_free(AVFilterInOut** @inout);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_graph_parse", CallingConvention = CallingConvention.Cdecl)]
        public static extern int avfilter_graph_parse(AVFilterGraph* @graph, [MarshalAs(UnmanagedType.LPStr)] string @filters, AVFilterInOut* @inputs, AVFilterInOut* @outputs, void* @log_ctx);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_graph_parse_ptr", CallingConvention = CallingConvention.Cdecl)]
        public static extern int avfilter_graph_parse_ptr(AVFilterGraph* @graph, [MarshalAs(UnmanagedType.LPStr)] string @filters, AVFilterInOut** @inputs, AVFilterInOut** @outputs, void* @log_ctx);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_graph_parse2", CallingConvention = CallingConvention.Cdecl)]
        public static extern int avfilter_graph_parse2(AVFilterGraph* @graph, [MarshalAs(UnmanagedType.LPStr)] string @filters, AVFilterInOut** @inputs, AVFilterInOut** @outputs);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_graph_send_command", CallingConvention = CallingConvention.Cdecl)]
        public static extern int avfilter_graph_send_command(AVFilterGraph* @graph, [MarshalAs(UnmanagedType.LPStr)] string @target, [MarshalAs(UnmanagedType.LPStr)] string @cmd, [MarshalAs(UnmanagedType.LPStr)] string @arg, IntPtr @res, int @res_len, int @flags);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_graph_queue_command", CallingConvention = CallingConvention.Cdecl)]
        public static extern int avfilter_graph_queue_command(AVFilterGraph* @graph, [MarshalAs(UnmanagedType.LPStr)] string @target, [MarshalAs(UnmanagedType.LPStr)] string @cmd, [MarshalAs(UnmanagedType.LPStr)] string @arg, int @flags, double @ts);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_graph_dump", CallingConvention = CallingConvention.Cdecl)]
        public static extern sbyte* avfilter_graph_dump(AVFilterGraph* @graph, [MarshalAs(UnmanagedType.LPStr)] string @options);
        
        [DllImport(libavfilter, EntryPoint = "avfilter_graph_request_oldest", CallingConvention = CallingConvention.Cdecl)]
        public static extern int avfilter_graph_request_oldest(AVFilterGraph* @graph);
        
        [DllImport(libavfilter, EntryPoint = "av_buffersrc_get_nb_failed_requests", CallingConvention = CallingConvention.Cdecl)]
        public static extern uint av_buffersrc_get_nb_failed_requests(AVFilterContext* @buffer_src);
        
        [DllImport(libavfilter, EntryPoint = "av_buffersrc_write_frame", CallingConvention = CallingConvention.Cdecl)]
        public static extern int av_buffersrc_write_frame(AVFilterContext* @ctx, AVFrame* @frame);
        
        [DllImport(libavfilter, EntryPoint = "av_buffersrc_add_frame", CallingConvention = CallingConvention.Cdecl)]
        public static extern int av_buffersrc_add_frame(AVFilterContext* @ctx, AVFrame* @frame);
        
        [DllImport(libavfilter, EntryPoint = "av_buffersrc_add_frame_flags", CallingConvention = CallingConvention.Cdecl)]
        public static extern int av_buffersrc_add_frame_flags(AVFilterContext* @buffer_src, AVFrame* @frame, int @flags);
        
        [DllImport(libavfilter, EntryPoint = "av_buffersink_get_frame_flags", CallingConvention = CallingConvention.Cdecl)]
        public static extern int av_buffersink_get_frame_flags(AVFilterContext* @ctx, AVFrame* @frame, int @flags);
        
        [DllImport(libavfilter, EntryPoint = "av_buffersink_params_alloc", CallingConvention = CallingConvention.Cdecl)]
        public static extern AVBufferSinkParams* av_buffersink_params_alloc();
        
        [DllImport(libavfilter, EntryPoint = "av_abuffersink_params_alloc", CallingConvention = CallingConvention.Cdecl)]
        public static extern AVABufferSinkParams* av_abuffersink_params_alloc();
        
        [DllImport(libavfilter, EntryPoint = "av_buffersink_set_frame_size", CallingConvention = CallingConvention.Cdecl)]
        public static extern void av_buffersink_set_frame_size(AVFilterContext* @ctx, uint @frame_size);
        
        [DllImport(libavfilter, EntryPoint = "av_buffersink_get_frame_rate", CallingConvention = CallingConvention.Cdecl)]
        public static extern AVRational av_buffersink_get_frame_rate(AVFilterContext* @ctx);
        
        [DllImport(libavfilter, EntryPoint = "av_buffersink_get_frame", CallingConvention = CallingConvention.Cdecl)]
        public static extern int av_buffersink_get_frame(AVFilterContext* @ctx, AVFrame* @frame);
        
        [DllImport(libavfilter, EntryPoint = "av_buffersink_get_samples", CallingConvention = CallingConvention.Cdecl)]
        public static extern int av_buffersink_get_samples(AVFilterContext* @ctx, AVFrame* @frame, int @nb_samples);
        
    }
}
#endif
