﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class AlphaCutOffScript : MonoBehaviour {

	 // How long to look at Menu Item before taking action
    public float timerDuration = 2f;
 
    // This value will count down from the duration
    private float lookTimer = 2f;
 
    // My renderer so I can set _Cutoff value
    private Renderer myRenderer;
 
    // Box Collider
    private BoxCollider myCollider;
 
    // Is player looking at me?
    public bool isLookedAt = false;

    public setupHLSConnection setupCon;
 
    // MonoBehaviour Start
    void Start() {
        // My Collider
        // myCollider = GetComponent<BoxCollider>();
        // Get my Renderer
        myRenderer = GetComponent<Renderer>();
        // Set cutoff
        myRenderer.material.SetFloat("_Cutoff", 0f);
        setupCon = GameObject.Find("sphere").GetComponent<setupHLSConnection>();
    }
   
    // MonoBehaviour Update
    void Update() {
        // While player is looking at me
        if (isLookedAt) {
            // Reduce Timer
            lookTimer -= Time.deltaTime;
 
            // Set cutoff value on material to value between 0 and 1
            myRenderer.material.SetFloat("_Cutoff", lookTimer / timerDuration);
 
            if (lookTimer < 0f) {
                // Reset timer
                lookTimer = 2f;
   
                // disable collider
                // myCollider.enabled = false;
 
                // Do something
                Debug.Log("BUTTON HAS BEEN SELECTED, WE ARE NOW SWITCHING!");
                setupCon.switchCameras();
 
                // Disappear
                // gameObject.SetActive(false);
            }    
        }  else {
            // Reset Timer
            lookTimer = 2f;
            // Reset Cutoff
            myRenderer.material.SetFloat("_Cutoff", 1f);
        }
    }
 
    // Google Cardboard Gaze
    // public void SetGazedAt(bool gazedAt) {
    //     // Set the local bool to the one passed from Event Trigger
    //     isLookedAt = gazedAt;
    // }
}